
!packhdr tmp.dat "E:\prog\upx\upx -9 tmp.dat"

;SetCompressor ZLIB
SetCompressor LZMA
CRCCheck force
LicenseForceSelection checkbox
ShowInstDetails show
ShowUninstDetails show
AllowSkipFiles off
SetOverwrite ifnewer


!define PRODUCT_NAME "OSCommerce Product Manager"
!define PRODUCT_VERSION "0.1.1.474"
!define PRODUCT_PUBLISHER "Mario A. Valdez-Ramrez"
!define PRODUCT_WEB_SITE "http://www.mariovaldez.net/software/oscpmwin/"
!define PRODUCT_DIR_REGKEY "Software\Microsoft\Windows\CurrentVersion\App Paths\oscpm1.exe"
!define PRODUCT_UNINST_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_NAME}"
!define PRODUCT_UNINST_ROOT_KEY "HKLM"
!define PRODUCT_STARTMENU_REGVAL "NSIS:StartMenuDir"

!define PRODUCT_REGDATA_ROOTKEY "HKCU"
!define PRODUCT_REGDATA_REGKEY "Software\OSCommerce\OSCPMWIN"

!include "MUI.nsh"
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "..\images\installhead.bmp"
!define MUI_WELCOMEFINISHPAGE_BITMAP "..\images\installstart.bmp"
!define MUI_UNWELCOMEFINISHPAGE_BITMAP "..\images\iinstallstart.bmp"
!define MUI_UNFINISHPAGE_NOAUTOCLOSE
!define MUI_COMPONENTSPAGE_CHECKBITMAP "${NSISDIR}\Contrib\Graphics\Checks\colorful.bmp"
!define MUI_ABORTWARNING
!define MUI_ICON "..\images\Applications.ico"
!define MUI_UNICON "..\images\Applications.ico"
!define MUI_WELCOMEPAGE_TITLE_3LINES
!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_LICENSE "..\docs\license.txt"
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
var ICONS_GROUP
!define MUI_STARTMENUPAGE_NODISABLE
!define MUI_STARTMENUPAGE_DEFAULTFOLDER "OSC Product Manager"
!define MUI_STARTMENUPAGE_REGISTRY_ROOT "${PRODUCT_UNINST_ROOT_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_KEY "${PRODUCT_UNINST_KEY}"
!define MUI_STARTMENUPAGE_REGISTRY_VALUENAME "${PRODUCT_STARTMENU_REGVAL}"
!insertmacro MUI_PAGE_STARTMENU Application $ICONS_GROUP
Page custom FinalNotesPage
!insertmacro MUI_PAGE_INSTFILES
!define MUI_FINISHPAGE_SHOWREADME "$INSTDIR\readme.txt"
!define MUI_FINISHPAGE_SHOWREADME_NOTCHECKED
!define MUI_FINISHPAGE_NOAUTOCLOSE
!define MUI_FINISHPAGE_LINK "Visit the OSCommerce Product Manager website"
!define MUI_FINISHPAGE_LINK_LOCATION "http://www.mariovaldez.net/software/oscpmwin/"
!define MUI_FINISHPAGE_TITLE_3LINES
!define MUI_FINISHPAGE_NOREBOOTSUPPORT
!insertmacro MUI_PAGE_FINISH
!insertmacro MUI_UNPAGE_INSTFILES
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "Spanish"
!insertmacro MUI_RESERVEFILE_LANGDLL
ReserveFile "finalnotes.ini"
!insertmacro MUI_RESERVEFILE_INSTALLOPTIONS

LangString TEXT_IO_TITLE ${LANG_ENGLISH} "Final notes"
LangString TEXT_IO_TITLE ${LANG_SPANISH} "Notas finales"
LangString TEXT_IO_SUBTITLE ${LANG_ENGLISH} "Read carefully these final notes."
LangString TEXT_IO_SUBTITLE ${LANG_SPANISH} "Lea cuidadosamente estas notas finales."
LangString FinalNote ${LANG_ENGLISH} "Don't forget: You need to install the PHP script file oscpm1_upload.php on your web server to enable the image management features. Also, if you want to use the SSH encrypted tunnel is highly recommended that you compile and install the dummy shell in your database server."
LangString FinalNote ${LANG_SPANISH} "No olvide: Necesitar instalar el archivo script de PHP oscpm1_upload.php en su servidor web para habilitar las funciones de administracin de imgenes. Adems, si desea usar el tunel SSH encriptado es muy recomendable que compile e instale el falso intrprete de comandos en el servidor de la base de datos."
LangString DescSec1 ${LANG_ENGLISH} "Basic system (required)"
LangString DescSec2 ${LANG_ENGLISH} "Supporting local libraries (required)"
LangString DescSec3 ${LANG_ENGLISH} "SSH encrypted tunnel (recommended)"
LangString DescSec4 ${LANG_ENGLISH} "Server-side PHP script for image management (recommended)"
LangString DescSec5 ${LANG_ENGLISH} "Extra synchronization modules (optional)"
LangString DescSec6 ${LANG_ENGLISH} "Dummy shell for SSH encrypted tunnel account (optional)"
LangString DescSec7 ${LANG_ENGLISH} "Localization language files (required)"
LangString DescSec8 ${LANG_ENGLISH} "Printing reports (recommended)"
LangString DescSec1 ${LANG_SPANISH} "Sistema bsico (requerido)"
LangString DescSec2 ${LANG_SPANISH} "Bibliotecas locales de apoyo (requeridas)"
LangString DescSec3 ${LANG_SPANISH} "Tnel SSH encriptado (recomendado)"
LangString DescSec4 ${LANG_SPANISH} "Script PHP de servidor para administracin de imgenes (recomendado)"
LangString DescSec5 ${LANG_SPANISH} "Mdulos de sincronizacin adicionales (opcional)"
LangString DescSec6 ${LANG_SPANISH} "Intrprete de comandos falso para cuenta de tnel SSH encriptado (opcional)"
LangString DescSec7 ${LANG_SPANISH} "Archivos de regionalizacin de idioma (requeridos)"
LangString DescSec8 ${LANG_SPANISH} "Reportes de impresin (recomendados)"


Name "${PRODUCT_NAME} ${PRODUCT_VERSION}"
OutFile "oscpmwin_${PRODUCT_VERSION}_setup.exe"
InstallDir "$PROGRAMFILES\oscpmwin"
InstallDirRegKey HKLM "${PRODUCT_DIR_REGKEY}" ""
ShowInstDetails show
ShowUnInstDetails show

VIProductVersion "${PRODUCT_VERSION}"
VIAddVersionKey "ProductName" "${PRODUCT_NAME} "
VIAddVersionKey "CompanyName" "${PRODUCT_PUBLISHER}"
VIAddVersionKey "LegalCopyright" " ${PRODUCT_PUBLISHER}"
VIAddVersionKey "FileDescription" "${PRODUCT_NAME}"
VIAddVersionKey "FileVersion" "${PRODUCT_VERSION}"
VIAddVersionKey "Comments" "${PRODUCT_WEB_SITE}"
VIAddVersionKey "ProductVersion" "${PRODUCT_VERSION}"
VIAddVersionKey "InternalName" "oscpmwin"
VIAddVersionKey "SpecialBuild" "Normal Release"




Section "!Main" SEC01
  SectionIn RO
  SetOutPath "$INSTDIR"
  CreateDirectory "$SMPROGRAMS\$ICONS_GROUP"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\OSCommerce Product Manager.lnk" "$INSTDIR\oscpm1.exe" "" "" "" "" "" "${PRODUCT_NAME} ${PRODUCT_VERSION}"
  CreateShortCut "$DESKTOP\OSCommerce Product Manager.lnk" "$INSTDIR\oscpm1.exe" "" "" "" "" "" "${PRODUCT_NAME} ${PRODUCT_VERSION}"
  SetOverwrite on
  File "..\oscpm1.exe"
  SetOverwrite ifnewer
  File "..\docs\license.txt"
  File "..\docs\putty_license.txt"
  File "..\docs\readme.txt"
  File "..\docs\version.txt"
  File "..\docs\install.txt"
SectionEnd



Section "!Libraries" SEC02
  SectionIn RO
  File "..\FreeImage.dll"
  File "..\libmysql320.dll"
  File "..\libmysql323.dll"
  File "..\libmysql40.dll"
SectionEnd

Section "SSH tunnel" SEC03
  SectionIn RO
  File "..\plink.exe"
SectionEnd

Section "PHP Script" SEC04
  SectionIn RO
  SetOutPath "$INSTDIR\serverside"
  File "..\serverside\oscpm1_upload.php"
SectionEnd

Section "Sync modules" SEC05
  SetOutPath "$INSTDIR\modules"
  File "..\modules\*.exe"
  File "..\modules\*.ini"
  File "..\modules\*.txt"
SectionEnd

Section "SSH dummy shell" SEC06
  SetOutPath "$INSTDIR\serverside"
  File "..\serverside\sleepshell_0.0.1.tar.gz"
SectionEnd

Section "!Languages" SEC07
  SectionIn RO
  SetOutPath "$INSTDIR\locale"
  File "..\locale\*.*"
  SetOutPath "$INSTDIR\locale\en\LC_MESSAGES"
  File "..\locale\en\LC_MESSAGES\*.*"
  SetOutPath "$INSTDIR\locale\es\LC_MESSAGES"
  File "..\locale\es\LC_MESSAGES\*.*"
  SetOutPath "$INSTDIR\locale\fr\LC_MESSAGES"
  File "..\locale\fr\LC_MESSAGES\*.*"
  SetOutPath "$INSTDIR\locale\hr\LC_MESSAGES"
  File "..\locale\hr\LC_MESSAGES\*.*"
  SetOutPath "$INSTDIR\locale\nl\LC_MESSAGES"
  File "..\locale\nl\LC_MESSAGES\*.*"
  SetOutPath "$INSTDIR\locale\ru\LC_MESSAGES"
  File "..\locale\ru\LC_MESSAGES\*.*"
SectionEnd

Section "Printing reports" SEC08
  SetOutPath "$INSTDIR\reports"
  File "..\reports\*.frf"
SectionEnd


Var HWND
Var DLGITEM
Var FONT

Function FinalNotesPage
  !insertmacro MUI_HEADER_TEXT "$(TEXT_IO_TITLE)" "$(TEXT_IO_SUBTITLE)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "finalnotes.ini" "Field 1" "Text" "$(TEXT_IO_SUBTITLE)"
  !insertmacro MUI_INSTALLOPTIONS_WRITE "finalnotes.ini" "Field 2" "State" "$(FinalNote)"
  !insertmacro MUI_INSTALLOPTIONS_INITDIALOG "finalnotes.ini"
  Pop $HWND
  GetDlgItem $DLGITEM $HWND 1201
  CreateFont $FONT "MS Shell Dlg" 10 700
  SendMessage $DLGITEM ${WM_SETFONT} $FONT 0
  GetDlgItem $DLGITEM $HWND 1200
  CreateFont $FONT "MS Shell Dlg" 10 700
  SendMessage $DLGITEM ${WM_SETFONT} $FONT 0
  !insertmacro MUI_INSTALLOPTIONS_SHOW
FunctionEnd


Section -AdditionalIcons
  WriteIniStr "$INSTDIR\${PRODUCT_NAME}.url" "InternetShortcut" "URL" "${PRODUCT_WEB_SITE}"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\OSCPMWin website.lnk" "$INSTDIR\${PRODUCT_NAME}.url"
  CreateShortCut "$SMPROGRAMS\$ICONS_GROUP\Uninstall OSCPMWin.lnk" "$INSTDIR\uninst.exe"
SectionEnd

Section -Post
  WriteUninstaller "$INSTDIR\uninst.exe"
  WriteRegStr HKLM "${PRODUCT_DIR_REGKEY}" "" "$INSTDIR\oscpm1.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayName" "$(^Name)"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "UninstallString" "$INSTDIR\uninst.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayIcon" "$INSTDIR\oscpm1.exe"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "DisplayVersion" "${PRODUCT_VERSION}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_REGVAL}" "$ICONS_GROUP"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "URLInfoAbout" "${PRODUCT_WEB_SITE}"
  WriteRegStr ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "Publisher" "${PRODUCT_PUBLISHER}"
SectionEnd


!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC01} "$(DescSec1)"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC02} "$(DescSec2)"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC03} "$(DescSec3)"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC04} "$(DescSec4)"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC05} "$(DescSec5)"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC06} "$(DescSec6)"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC07} "$(DescSec7)"
  !insertmacro MUI_DESCRIPTION_TEXT ${SEC08} "$(DescSec8)"
!insertmacro MUI_FUNCTION_DESCRIPTION_END


Function .onInit
  System::Call 'kernel32::CreateMutexA(i 0, i 0, t "oscpmwinmutex") i .r1 ?e'
  Pop $R0
  StrCmp $R0 0 +3
    MessageBox MB_OK "The ${PRODUCT_NAME} installer is already running."
    Abort
  !insertmacro MUI_LANGDLL_DISPLAY
  !insertmacro MUI_INSTALLOPTIONS_EXTRACT "finalnotes.ini"
FunctionEnd


Function .onInstSuccess
;  MessageBox MB_ICONINFORMATION|MB_OK "$(FinalNote)"
FunctionEnd

Function un.onUninstSuccess
  HideWindow
  MessageBox MB_ICONINFORMATION|MB_OK "Uninstalling $(^Name) done."
FunctionEnd

Function un.onInit
  MessageBox MB_ICONQUESTION|MB_YESNO|MB_DEFBUTTON2 "Are you sure you want to uninstall $(^Name) and all its components?" IDYES +2
  Abort
FunctionEnd

Section Uninstall
  ReadRegStr $ICONS_GROUP ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}" "${PRODUCT_STARTMENU_REGVAL}"
  Delete "$INSTDIR\${PRODUCT_NAME}.url"
  Delete "$INSTDIR\uninst.exe"
  Delete "$INSTDIR\modules\*.txt"
  Delete "$INSTDIR\modules\*.exe"
  Delete "$INSTDIR\serverside\*.*"
  Delete "$INSTDIR\reports\*.*"
  Delete "$INSTDIR\plink.exe"
  Delete "$INSTDIR\*.txt"
  Delete "$INSTDIR\*.dll"
  Delete "$INSTDIR\oscpm1.exe"

  Delete "$SMPROGRAMS\$ICONS_GROUP\Uninstall OSCPMWin.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\OSCPMWin website.lnk"
  Delete "$DESKTOP\OSCommerce Product Manager.lnk"
  Delete "$SMPROGRAMS\$ICONS_GROUP\OSCommerce Product Manager.lnk"

  RMDir "$SMPROGRAMS\$ICONS_GROUP"
  RMDir /r "$INSTDIR\serverside"
  RMDir /r "$INSTDIR\locale"
  RMDir "$INSTDIR\modulos"
  RMDir "$INSTDIR\reports"
  RMDir "$INSTDIR"

  DeleteRegKey ${PRODUCT_UNINST_ROOT_KEY} "${PRODUCT_UNINST_KEY}"
  DeleteRegKey HKLM "${PRODUCT_DIR_REGKEY}"
  DeleteRegKey ${PRODUCT_REGDATA_ROOTKEY} "${PRODUCT_REGDATA_REGKEY}"
  SetAutoClose true
SectionEnd

